/*
 * Created on Jun 24, 2003
 *  
 */
package isac.util.genhtml;

import isac.util.InformationProcessor;

import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * @author Andreas Griesmayer
 *  
 */
public class GenHTML {

    static final int PBLTREE_XSL = 1;

    static final int METTREE_XSL = 2;

    static final int EXPTREE_XSL = 3;

    static final int SIMPLE_HIERARCHY_XSL = 4;

    static final int SIMPLE_PBL_NODE = 5;

    //static String destination_ = "/netshares/studenthomes/mlang/proto_v2/isac/proto2/isac/xmldata/";
    static String destination_ = "/netshares/studenthomes/mlang/xmldata/";	
    
    
    /**
     * Method derived from HttpServlet to react on an request by an web-browser
     * AG? ................^^^^^^^^^^^ ???
     * 
     * @param request
     *            object which holds informations about the request like the URL
     *            used to access this servlet
     * @param arg1
     *            object which provides methods to return the results to the
     *            web-browser.
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest,
     *      javax.servlet.http.HttpServletResponse)
     */

    public static void main(String[] argv) {
        if (argv.length > 0) destination_ = argv[0];
        GenHTML genhtml = new GenHTML();
        genhtml.buildHierarchy("met/code.html");
        genhtml.buildHierarchy("met/index.html");
        genhtml.buildHierarchy("met/heading.html");
        genhtml.buildHierarchy("met/menu_empty.html");
        genhtml.buildHierarchy("met/main.html");

        genhtml.buildHierarchy("pbl/code.html");
        genhtml.buildHierarchy("pbl/index.html");
        genhtml.buildHierarchy("pbl/heading.html");
        genhtml.buildHierarchy("pbl/menu_empty.html");
        genhtml.buildHierarchy("pbl/main.html");

        genhtml.buildHierarchy("exp/code.html");
        genhtml.buildHierarchy("exp/index.html");
        genhtml.buildHierarchy("exp/heading.html");
        genhtml.buildHierarchy("exp/menu_empty.html");
        genhtml.buildHierarchy("exp/main.html");

        Set exp_set = genhtml.loadFileList("exp");
        Iterator exp_it = exp_set.iterator();
        int index = exp_set.size();
        while (exp_it.hasNext()) {
            System.out.println("exp to generate:" + (index--));
            genhtml.loadContent("exp/" + exp_it.next());
        }

        Set pbl_set = genhtml.loadFileList("pbl");
        index = pbl_set.size();
        Iterator pbl_it = pbl_set.iterator();
        while (pbl_it.hasNext()) {
            System.out.println("pbl to generate:" + (index--));
            genhtml.loadContent("pbl/" + pbl_it.next());
        }

        Set met_set = genhtml.loadFileList("met");
        index = met_set.size();
        Iterator met_it = met_set.iterator();
        while (met_it.hasNext()) {
            System.out.println("met to generate:" + (index--));
            genhtml.loadContent("met/" + met_it.next());
        }

    }

    Set loadFileList(String type) {
        Set return_set = new HashSet();
        try {

            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            String h_xml = InformationProcessor.loadHierarchy("", type);
            InputSource inputsource = new InputSource(new StringReader(h_xml));
            Document document = db.parse(inputsource);

            Element doc_elem = document.getDocumentElement();
            NodeList nodelist = doc_elem.getElementsByTagName("CONTENTREF");
            for (int index = 0; index < nodelist.getLength(); index++) {
                return_set.add(nodelist.item(index).getFirstChild()
                        .getNodeValue().trim());
            }

            nodelist = doc_elem.getElementsByTagName("EXAMPLE");
            for (int index = 0; index < nodelist.getLength(); index++) {
                return_set.add(nodelist.item(index).getFirstChild()
                        .getNodeValue().trim());
            }
        } catch (ParserConfigurationException e) {
            e.printStackTrace();
        } catch (SAXException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return return_set;
    }

    /**
     * Loads all hierarchies which are displayed on the web-browser
     */
    protected void buildHierarchy(String path) {
        String session = "";
        StringTokenizer tokens = new StringTokenizer(path, "/");
        //	(String)request.getSession().getAttribute("session_id");
        //	if(session==null)
        //	    session="";
        path = "";
        String type = tokens.nextToken();

        if (!tokens.hasMoreTokens())
            path = "/index.html";
        else
            while (tokens.hasMoreTokens())
                path += "/" + tokens.nextToken();
        try {
            if (path.endsWith("code.html")) {
                Vector parameter = new Vector();
                parameter.add(session);
                parameter.add(type);
                Vector result;
                Source xslSource = null;
                Source xmlSource = new StreamSource(new StringReader(
                        InformationProcessor.loadHierarchy(session, type)));
                if (type.equals("pbl"))
                    xslSource = new StreamSource(
                            getClass()
                                    .getResourceAsStream(
                                            "/isac/util/genhtml/templates/pbl_hierarchy_jmenu.xsl"));
                else if (type.equals("met"))
                    xslSource = new StreamSource(
                            getClass()
                                    .getResourceAsStream(
                                            "/isac/util/genhtml/templates/met_hierarchy_jmenu.xsl"));
                else
                    xslSource = new StreamSource(
                            getClass()
                                    .getResourceAsStream(
                                            "/isac/util/genhtml/templates/exp_hierarchy_jmenu.xsl"));
                String header = toString(getClass().getResourceAsStream(
                        "/isac/util/genhtml/templates/codeheader.html"));
                String footer = toString(getClass().getResourceAsStream(
                        "/isac/util/genhtml/templates/codefooter.html"));

                // Perform the transformation, sending the output to the
                // response.
                //java.io.PrintWriter out = response.getWriter();
                FileWriter out = new FileWriter(destination_ + type + "/"
                        + path);
                out.write(header);
                Encoder.encodeInformation(xslSource, xmlSource, out);
                out.write(footer);
                out.close();
            } else {
                if (path.trim().endsWith("index.html")) {
                    if (type.equals("pbl")) {
                        path = "index_pbl.html";
                    } else if (type.equals("met"))
                        path = "index_met.html";
                    else
                        path = "index_exp.html";
                }
                System.out.println(path);
                InputStream istream = getClass().getResourceAsStream(
                        "/isac/util/genhtml/jscript/" + path);
                FileWriter out = new FileWriter(destination_ + type + "/"
                        + path);
                int input;
                while ((input = istream.read()) != -1) {
                    out.write(input);
                }
                out.close();
            }

        } catch (IOException exc) {
            System.out.println("IOException:" + exc.getMessage());
        }
    }

    private String toString(InputStream istream) {
        StringBuffer buf = new StringBuffer(10000);
        int input;
        try {
            while ((input = istream.read()) != -1) {
                buf.append((char) input);
            }
        } catch (IOException e) {
            return getErrorXML("Sorry, IOException while accessing the InputStream "
                    + e.getMessage());
        }
        return buf.toString();
    }

    private static String getErrorXML(String string) {
        return "<ERROR><DESCRIPTION> <h1> Error in file LoadHierarchy.java </h1>"
                + string + "</DESCRIPTION></ERROR>";
    }

    protected void loadFile(String path) {
        StringTokenizer tokens = new StringTokenizer(path, "/");
        //		(String)request.getSession().getAttribute("session_id");
        //		if(session==null)
        //			session="";
        String session_id = "";
        path = "";
        String type = (String) tokens.nextToken();

        if (!tokens.hasMoreTokens())
            path = "/index.html";
        else
            while (tokens.hasMoreTokens())
                path += "/" + tokens.nextToken();
        try {
            if (path.endsWith("code.html")) {
                Vector parameter = new Vector();
                parameter.add(session_id);
                parameter.add(type);
                Vector result;
                Source xmlSource = new StreamSource(new StringReader(
                        InformationProcessor.loadHierarchy(session_id, type)));

                // Perform the transformation, sending the output to the
                // response.
                java.io.FileWriter out = new FileWriter(destination_ + type
                        + "/" + path);
                Encoder.encodeHierarchy(type, xmlSource, out);
                return;
            } else if (path.trim().endsWith("heading.html")) {
                java.io.FileWriter out = new FileWriter(destination_ + type
                        + "/" + path);
                out.write(getHeader(session_id));
                return;
            } else if (path.trim().endsWith("treecontent.html")) {
                Vector parameter = new Vector();
                parameter.add(session_id);
                parameter.add(type);
                Vector result;
                Source xmlSource = new StreamSource(new StringReader(
                        InformationProcessor.loadHierarchy(session_id, type)));

                // Perform the transformation, sending the output to the
                // response.
                java.io.FileWriter out = new FileWriter(destination_ + type
                        + "/" + path);

                Encoder.encodeHContent(type, xmlSource, out);
                return;
            }
            //TODO this type should not result in different files but in an
            // autogeneration of a fitting file
            if (path.trim().endsWith("index.html")) {
                if (type.equals("pbl")) {
                    path = "index_pbl.html";
                } else if (type.equals("met"))
                    path = "index_met.html";
                else
                    path = "index_exp.html";
            }
            InputStream istream = getClass().getResourceAsStream(
                    "/isac/BrowserServlet/jscript/" + path);
            java.io.FileWriter out = new FileWriter(destination_ + type + "/"
                    + path);
            int input;
            while ((input = istream.read()) != -1) {
                out.write(input);
            }

        } catch (IOException exc) {
            System.out.println("bla");
        }
    }

    private String getHeader(String session_id) {
        String headercontent = "<html>"
                + "<body>"
                + "<a href=\"../../isac.BrowserServlet.Login\" target=\"text\">"
                + " login </a>"
                + "&nbsp;&nbsp;"
                + "<a href=\"../../isac.BrowserServlet.Logout\" target=\"text\">"
                + " logout </a>"
                + "<br> <a href=\"../../isac.BrowserServlet.LoadFile/pbl/index.html\" target=\"_top\">PBLHierarchy</a>"
                + "&nbsp;&nbsp;<a href=\"../../isac.BrowserServlet.LoadFile/met/index.html\" target=\"_top\">METHierarchy</a>"
                + "&nbsp;&nbsp;<a href=\"../../isac.BrowserServlet.LoadFile/exp/index.html\" target=\"_top\">ExampleHierarchy</a>"
                + "&nbsp;&nbsp;";

        String username;
        if ((username = InformationProcessor.getUsername(session_id)) == null)
            headercontent += "not logged in";
        else
            headercontent += " welcome <b>" + username + "</b>";
        headercontent += "</body> </html>";
        return headercontent;
    }

    protected void loadContent(String path) {
        StringTokenizer tokens = new StringTokenizer(path, "/");

        String session = "";

        Vector parameter = new Vector();
        parameter.add(session);
        try {
            Source xslSource = null;
            Source xmlSource = null;

            String command = tokens.nextToken();
            String header = "<?xml version=\"1.0\"?> \n"
                    + "<?xml-stylesheet href=\"http://pear.math.pitt.edu/mathzilla/Examples/mml.css\" type=\"text/css\"?>\n"
                    + "<!DOCTYPE html SYSTEM \"mathml.dtd_\">\n" +
                    //"<?xml-stylesheet type=\"text/xsl\"
                    // href=\"http://www.w3.org/Math/XSL/pmathml.xsl\"?>\n"+
                    //" <HTML xmlns=\"http://www.w3.org/1999/xhtml\">\n"+
                    "<HTML xmlns=\"http://www.w3.org/1999/xhtml\"\n"
                    + "xmlns:math=\"http://www.w3.org/1998/Math/MathML\"\n"
                    + "xmlns:xlink=\"http://www.w3.org/1999/xlink\">\n"
                    + "<BODY>";

            String footer = "</BODY>\n</HTML>";
            //		if(command.equals("pbl-node")){
            FileWriter out;
            parameter.add(command);
            if (!tokens.hasMoreElements()) {
                out = new FileWriter(destination_ + path + ".html");
                out.write(header);
                out.write("no details");
                out.write(footer);
                return;
            }
            String contentfile = tokens.nextToken();
            parameter.add(contentfile);

            if (!contentfile.trim().endsWith(".xml")) { return; }
            out = new FileWriter(destination_ + path + ".html");
            xmlSource = new StreamSource(new StringReader(InformationProcessor
                    .loadXML(session, command, contentfile)));
            xslSource = new StreamSource(getClass().getResourceAsStream(
                    "/isac/util/genhtml/templates/pbl_node_content.xsl"));
            //		}
            // Perform the transformation, sending the output to the response.
            out.write(header);
            Encoder.encodeInformation(xslSource, xmlSource, out);
            out.write(footer);
        } catch (IOException exc) {
            exc.printStackTrace();
        }
        //	arg1.getWriter().print("pathinfo: "+arg0.getPathInfo()+"\n
        // transl:"+arg0.getPathTranslated());
    }

}